import java.awt.*;
import java.awt.event.*;

/**
 * Hauptklasse.
 * Hier werden die Daten initialisiert und die graphicsche Ausgabe gestartet.
 */
class Rechnungsbearbeitung {
    private Artikel artikelDaten;
    private Rechnung rechnungsDaten;
    
    final static String ARTIKELPFAD = "f:\\daten\\uni\\1.semester\\eprog\\abgabe3\\Files\\";
    final static String ARTIKELFILE = "artikel.txt";
    final static String RECHNUNGSPFAD = "f:\\daten\\uni\\1.semester\\eprog\\abgabe3\\Files\\";
    
    /**
     * Konstruktor.
     * Versucht die Daten einzulesen. Falls dies nicht mgliche ist, wird das Programm mit
     * einer Fehlermeldung abgebrochen.
     */
    Rechnungsbearbeitung () {
	try {
	    artikelDaten = new Artikel (ARTIKELPFAD, ARTIKELFILE);
	    rechnungsDaten = new Rechnung (RECHNUNGSPFAD);
	    }
	catch (MyException e) {
	    System.out.println (e.getMessage());
	    System.exit (0);
	    }

	// Startet graphische Ausgabe
	MyGUI m = new MyGUI (artikelDaten, rechnungsDaten);
	rechnungsDaten.addObserver (m);
	}
    
    /**
     * Hauptmethode.
     * Initialisiert Rechnungsdaten, Artikeldaten und Frame.
     */
    public static void main (String argv[]) {
	Rechnungsbearbeitung r = new Rechnungsbearbeitung ();
	}
    }