import java.awt.*;
import java.awt.event.*;
import java.util.*;

/**
 * Dialog Bearbeiten.
 * Ermglicht das Bearbeiten einer oder mehrerer Rechnungen.
 * Zur Zeit ist nur das Lschen von Artikeln in Rechnungen und das bearbeiten von Artikeln mglich.
 */
class DialogBearbeiten extends Dialog implements ActionListener, ItemListener, Observer {
    Choice choiceRechnungen = new Choice();
    Panel pEingabe = new Panel ();
    List lElements = new List (5, false);
    Button bNeu = new Button ("Neu");
    Button bEd = new Button ("Bearbeiten");
    Button bDel = new Button ("Lschen");
    Button bOk = new Button ("OK");
    TextField tfArt = new TextField ();
    Rechnung rechnungsDaten;
    Artikel artikelDaten;
    Frame parent;


    /**
     * Methode: Update.
     * Fhrt bei einer Vernderung des zu berwachenden Objektes die fillListmethode des Dialoges aus.
     * @param o - das berwachte Objekt.
     * @param arg - die Vernderung.
     */
    public void update(Observable o, Object arg) {
	fillList ();
	}
    
	    
    /**
     * Konstrukor.
     * Hier wird der Dialog initialisiert.
     */
    DialogBearbeiten (Frame p, String titel, boolean modal, Rechnung v, Artikel a) {
	super(p,titel);
	parent = p;
	rechnungsDaten = v;
	artikelDaten = a;
	setBackground(Color.lightGray);
	setResizable(false);
	setLayout(new BorderLayout());
	
	// Choice fllen
        for (int i = 0; i < rechnungsDaten.RechnungsSize (); i++)
	    choiceRechnungen.add(rechnungsDaten.getName(i));
	
	// Fllt die Liste    
	fillList ();
		    	    
	pEingabe.setLayout(new GridLayout(3,1));
	pEingabe.add(bNeu);
	pEingabe.add(bEd);
	pEingabe.add(bDel);
	
	choiceRechnungen.addItemListener(this);
	bOk.addActionListener(this);
	bNeu.addActionListener(this);
	bDel.addActionListener(this);
	bEd.addActionListener(this);
	
	lElements.addActionListener (this);
	lElements.addItemListener (this);
	
	add ("North", choiceRechnungen);
	add ("Center", lElements);
	add ("East", pEingabe);
	add ("South", bOk);

	// WindowListener zum Schlieen des Dialoges
	addWindowListener(new Dialogschliesser ());		
	pack();
	}


    /**												      	    											  	      
     * Schliet das Dialogfenster.
     */
    class Dialogschliesser extends WindowAdapter
	{
	public void windowClosing (WindowEvent e)
	    {cancel ();}
	}	
	
    
    /**
     * methode fillList.
     * Fllt die Liste mit dem Inhalt einer Rechnung.
     */    
    private void fillList () {
	String sRechnung;
	    
	// selektierte Rechnungsnummer holen
	if ((sRechnung = choiceRechnungen.getSelectedItem()) == null)
	    cancel ();
	
	lElements.removeAll ();
	rechnungsDaten.resetRechnung ();
	rechnungsDaten.findRechnung (sRechnung);
	
	for (int i = 0; i < rechnungsDaten.elementsSize (); i++) {
	    lElements.add (artikelDaten.name ("" + rechnungsDaten.elementArtikel ()) + "    " + rechnungsDaten.elementMenge ());
	    rechnungsDaten.nextElement ();
	    }
	}


    /**
     * Beendet den Dialog und kehrt zurck zum Hauptframe.
     */
    void cancel() {
	setVisible(false);
	dispose();
	((Window)getParent()).toFront();
	getParent().requestFocus();
	}


    /**
     * Wertet die ActionEvent aus und reagiert je nach Event.
     */
    public void actionPerformed (ActionEvent e) {		    
	// Beendet Bearbeitung
	if (e.getActionCommand().equals("OK")) cancel();
	
	// noch nicht ausprogrammiert
	else if (e.getActionCommand().equals("Neu")) cancel();
	
	// Startet einen neuen Dialog zum vernder des ausgewhlten Artikels
	else if (e.getActionCommand().equals("Bearbeiten")) {
	    String s = lElements.getSelectedItem ();
	    DialogEditElement dEd;
	
	    if (s != null) {
		dEd = new DialogEditElement (parent, s, artikelDaten, rechnungsDaten);
		dEd.setVisible (true);
		}
	    }
	
	// Lscht den ausgewhlten Artikeleintrag einer Rechnung
	else if (e.getActionCommand().equals("Lschen")) lschen();
	}
	
    
    /**
     * methode itemStateChanged.
     * Verarbeitet die Item Events des Choice- und Listobjekts..
     */
    public void itemStateChanged (ItemEvent e) {
	// Wenn eine andere Rechnung ausgewhlt wurde - aktualisieren
	if (e.getSource () != lElements)
	    fillList ();
	}

		
    /**
     * Lscht das selektierte Listenelement.
     */
    public void lschen() {
	String sElement;
	
	// selektierte Rechnungsnummer holen
	if ((sElement = lElements.getSelectedItem()) != null)
	    {	    
	    // Rechnungsnummer aus Choice entfernen
	    lElements.remove (sElement);			
	    
	    // Rechnungsnummer aus Daten entfernen
	    rechnungsDaten.removeElement (sElement, artikelDaten);
	    }
    	}
    }    