import java.awt.*;
import java.awt.event.*;
    
/**
 * Editiert ein Artikelelements.
 */
class DialogEditElement extends Dialog implements ActionListener, ItemListener {
    Button bOk = new Button ("OK");
    Button bCancel = new Button ("Cancel");
    Panel p = new Panel ();
    TextField tf = new TextField ("0", 1);
    Label lb = new Label ();
    Artikel artikelDaten;
    Rechnung rechnungsDaten;
    String art;
    

    DialogEditElement (Frame parent, String s, Artikel a, Rechnung r) {
	super(parent, "Edit");
	artikelDaten = a;
	rechnungsDaten = r;
	art = s;

	// Setzt Parameter fr Dialog	
        setBackground(Color.lightGray);
        setResizable(false);
        setLayout(new BorderLayout());
	
	// Initialisiert die ActionListener
	bOk.addActionListener (this);
	bCancel.addActionListener (this);
	lb.setText ("Stck: " + s.substring (0, s.indexOf (" ")));
	tf.setText (s.substring (s.indexOf (" ") + 4, s.length ()));
	
	// Fgt buttons in Panel ein
	p.setLayout (new GridLayout(1, 2));
	  p.add (bOk);
	  p.add (bCancel);
	
	// Positioniert die Objekte im Dialog
	add ("Center", tf);
	add ("North", lb);
	add ("South", p);	

        // WindowListener zum Schlieen des Dialoges
        addWindowListener(new Dialogschliesser ());		
	
	// Richtet Objekte ein
        pack();
        }

    class Dialogschliesser extends WindowAdapter
	{
	public void windowClosing (WindowEvent e)
	    {cancel ();}
	}	

    /**
     * Beendet den Dialog und kehrt zurck zum Hauptframe.
     */
    void cancel() {
	setVisible(false);
	dispose();
	((Window)getParent()).toFront();
	getParent().requestFocus();
	}		        	    	    


    /**
     * Verarbeitet ActionEvents.
     */
    public void actionPerformed (ActionEvent e) {		    
	// Beendet Bearbeitung, wenn Eingabe korrekt
	if (e.getActionCommand().equals ("OK")) 
	    {
	    boolean err = false;
	    int menge = 0;
	    try {menge = Integer.parseInt (tf.getText ());}
	    catch (NumberFormatException ex) {err = true;}
	    
	    // Wenn kein Fehler aufgetreten ist - sichern
	    if ((menge > 0) && !err) {
		rechnungsDaten.setMenge (menge, artikelDaten.getArtikelNr (art));
		cancel ();	  
		}
	    }
	    
	// Beendet Bearbeitung sofort - ohne nderung
	if (e.getActionCommand().equals ("Cancel")) 
	    cancel ();
	}        

    /**
     * methode itemStateChanged.
     * Verarbeitet die Item Events des Choice- und Listobjekts..
     */
    public void itemStateChanged (ItemEvent e) {
	}		
    }
