import java.awt.*;
import java.awt.event.*;

/**
 * Dialog Lschen.
 * Lschen einer oder mehrerer Rechnungen.
 */
class DialogLoeschen extends Dialog implements ActionListener, ItemListener {
    List choiceRechnungen = new List (5, false);
    Panel pEingabe = new Panel();
    Button bOk = new Button("OK");
    Button bCancel = new Button ("Cancel");
    Rechnung rechnungsDaten;

    
    /**
     * Konstrukor.
     * Hier wird der Dialog initialisiert.
     */
    DialogLoeschen(Frame parent, String titel, boolean modal, Rechnung v) {
	super(parent,titel);
	rechnungsDaten = v;
	setBackground(Color.lightGray);
	setResizable(false);
	
	// Liste fllen
        for (int i = 0; i < rechnungsDaten.RechnungsSize (); i++)
	    choiceRechnungen.add(rechnungsDaten.getName(i));
	    
	pEingabe.setLayout(new GridLayout(2,1));
	  pEingabe.add(bOk);
	  pEingabe.add(bCancel);
	  bOk.addActionListener(this);
	  bCancel.addActionListener(this);
	
	choiceRechnungen.addItemListener(this);
	add("Center", choiceRechnungen);
	add("South", pEingabe);

	// WindowListener zum Schlieen des Dialoges
	addWindowListener(new Dialogschliesser ());		
	pack();
	}

		
    /**												      	    											  	      
     * Schliet das Dialogfenster.
     */
    class Dialogschliesser extends WindowAdapter
	{
	public void windowClosing (WindowEvent e)
	    {cancel ();}
	}	


    /**
     * Beendet den Dialog und kehrt zurck zum Hauptframe.
     */
    void cancel() {
	setVisible(false);
	dispose();
	((Window)getParent()).toFront();
	getParent().requestFocus();
	}
	
	        
    /**
     * Wertet die ActionEvent aus und reagiert je nach Event.
     */	    
    public void actionPerformed (ActionEvent e) {
	// lschen aufrufen
	if (e.getActionCommand().equals("OK")) lschen();
	
	// Zurck zum Hauptframe
	if (e.getActionCommand().equals("Cancel")) cancel();    
	}
	
	
    /**
     * methode itemStateChanged.
     * Verarbeitet die Item Events der Listbox.
     */
    public void itemStateChanged (ItemEvent e) {}

	    	    
    /**
     * Methode lschen.
     * Lscht die ausgewhlte Rechnung.
     */
    void lschen() {
	// selektierte Rechnungsnummer holen
	String sRechnung = choiceRechnungen.getSelectedItem();
	    
	if (sRechnung != null)
	    {	    
	    // Rechnungsnummer aus Choice entfernen
	    choiceRechnungen.remove (sRechnung);			
	    
	    // Rechnungsnummer aus Daten entfernen
	    rechnungsDaten.removeRechnung (sRechnung);
	
	    if (rechnungsDaten.RechnungsSize () == 0)
		cancel ();
	    }
    	}
    }    