import java.awt.*;
import java.awt.event.*;
import java.util.*;

/**
 * Dialog Neu.
 * Fgt eine Rechnung hinzu.
 * Noch nicht funktionstchtig, da noch die Ausprogrammierung der Artikelauswahl fehlt.
 */
class DialogNeu extends Dialog implements ActionListener, ItemListener {
    Panel pEingabe = new Panel ();
    Label errMsg = new Label ("", Label.CENTER);
    TextField tfNr = new TextField("0", 1);
    TextField tfKassa = new TextField("0", 1);    
    Button bCancel = new Button ("Cancel");
    Button bOk = new Button ("OK");
    Rechnung rechnungsDaten;
    Artikel artikelDaten;

    
    /**
     * Konstrukor.
     * Hier wird der Dialog initialisiert.
     */
    DialogNeu (Frame parent, String titel, boolean modal, Rechnung v, Artikel a) {
	super(parent,titel);
	rechnungsDaten = v;
	artikelDaten = a;
	setBackground(Color.lightGray);
	setResizable(false);
	setLayout(new BorderLayout());
	
	pEingabe.setLayout (new GridLayout(3,2));
	pEingabe.add (new Label ("Rechnungnummer:"));
	pEingabe.add (new Label ("Kassa:"));
	pEingabe.add (tfNr);
	pEingabe.add (tfKassa);
	pEingabe.add (bOk);
	pEingabe.add (bCancel);
	
	bOk.addActionListener (this);
	bCancel.addActionListener (this);
	
	add ("Center", pEingabe);
	add ("South", errMsg);

	// WindowListener zum Schlieen des Dialoges
	addWindowListener(new Dialogschliesser ());		
	pack();
	}

		
    /**												      	    											  	      
     * Schliet das Dialogfenster.
     */
    class Dialogschliesser extends WindowAdapter
	{
	public void windowClosing (WindowEvent e)
	    {cancel ();}
	}	
	
    
    /**
     * Beendet den Dialog und kehrt zurck zum Hauptframe.
     */
    void cancel() {
	setVisible(false);
	dispose();
	((Window)getParent()).toFront();
	getParent().requestFocus();
	}


    /**
     * Wenn Button gedrckt wurde	    	    
     */
    public void actionPerformed (ActionEvent e) {		    
	// Beendet Bearbeitung
	if (e.getActionCommand().equals("Cancel")) cancel();
	
	// Fgt neue Rechnung hinzu
	else if (e.getActionCommand().equals("OK")) add();
	}
	
    
    /**
     * methode itemStateChanged.
     * Verarbeitet die Item Events des Choice- und Listobjekts..
     */
    public void itemStateChanged (ItemEvent e) {
	}

		
    /**
     * Fgt die neue Rechnung zu den Daten hinzu.
     */
    public void add() {
	String sElement;
	int nr = 0, kassa = 0;
	boolean err = false;

	errMsg.setText ("");		
	
	try {nr = Integer.parseInt (tfNr.getText ());}
	catch (
	    NumberFormatException e) {errMsg.setText ("Ungltige Rechnungsnummer");
	    err = true;
	    }
	    
	try {kassa = Integer.parseInt (tfKassa.getText ());}
	catch (
	    NumberFormatException e) {errMsg.setText ("Ungltige Kassennummer");
	    err = true;
	    }
	
	// Wenn die Rechnungsnummer ungltig ist
	if ((nr <= 0) && !err) {
	    err = true;
	    errMsg.setText ("Rechnungsnummer zu klein");
	    }
	
	// Wenn die Kassennummer ungltig ist
	else if ((kassa <= 0) && !err) {
	    err = true;
	    errMsg.setText ("Kassennummer zu klein");
	    }
	
	// Wenn die Rechnung schon existiert    
	else if (rechnungsDaten.RechnungExists (nr)) {
	    err = true;
	    errMsg.setText ("Rechnung existiert bereits");
	    }

	// Wenn kein Fehler aufgetreten ist, wird die neue Rechnung angelegt
	if (!err) {
	    Vector v = new Vector ();
	    
	    if (rechnungsDaten.addRechnung (nr, kassa, v))
		errMsg.setText ("Daten angelegt");
	    else
		errMsg.setText ("Rechnung ist leer");
	    }
    	}
    }    